#include <cmath>
#define ALLEGRO_FIX_H  // Don't use Allegro's fix class
#include <allegro.h>
#include <winalleg.h>
#include "Duke.h"

#define GB_VIEWMODE		GFX_AUTODETECT
#define GB_VIEWSIZE_X	640
#define GB_VIEWSIZE_Y	480
#define GB_USEVIDBUF	0

#define GB_DEG2RAD 0.0174532925f

void gbBuildEye(gbFloat* fvIn, gbFloat fX, gbFloat fY, gbFloat fAngle, gbFloat* fvOut);

volatile gbInt g_dwMainTime = 0;
void MainTimer()
{
	g_dwMainTime++;
}
END_OF_FUNCTION();

void main()
{
	LOCK_VARIABLE(g_dwMainTime);
	LOCK_FUNCTION(MainTimer);

	allegro_init();
	set_color_depth(32);
	if(set_gfx_mode(GB_VIEWMODE, GB_VIEWSIZE_X, GB_VIEWSIZE_Y, 0, 0))
	{
		set_color_depth(32);
		if(set_gfx_mode(GB_VIEWMODE, GB_VIEWSIZE_X, GB_VIEWSIZE_Y, 0, 0))
		{
			set_color_depth(32);
			if(set_gfx_mode(GB_VIEWMODE, GB_VIEWSIZE_X, GB_VIEWSIZE_Y, 0, 0))
			{
				set_color_depth(32);
				if(set_gfx_mode(GB_VIEWMODE, GB_VIEWSIZE_X, GB_VIEWSIZE_Y, 0, 0))
				{
					allegro_message("Couldn't set graphics mode to %dx%d", GB_VIEWSIZE_X, GB_VIEWSIZE_Y);
					exit(-1);
				}
			}
		}
	}

#if GB_USEVIDBUF==1
	BITMAP* pMainBB = create_video_bitmap(SCREEN_W, SCREEN_H);
	BITMAP* pBB = create_video_bitmap(SCREEN_W, SCREEN_H);
#else
	BITMAP* pBB = create_bitmap(SCREEN_W, SCREEN_H);
#endif

	install_mouse();
	install_keyboard();
	install_timer();

	dkMap sMap;
	dkVertex_p pVert1 = sMap.CreateVertex(-16.0f, -16.0f);
	dkVertex_p pVert2 = sMap.CreateVertex(16.0f, -16.0f);
	dkVertex_p pVert3 = sMap.CreateVertex(16.0f, 16.0f);
	dkVertex_p pVert4 = sMap.CreateVertex(-16.0f, 16.0f);
	dkVertex_p pVert5 = sMap.CreateVertex(-24.0f, 0.0f);

	dkVertex_p pCVert1 = sMap.CreateVertex(-4.0f, 4.0f);
	dkVertex_p pCVert2 = sMap.CreateVertex(4.0f, 4.0f);
	dkVertex_p pCVert3 = sMap.CreateVertex(4.0f, -4.0f);
	dkVertex_p pCVert4 = sMap.CreateVertex(-4.0f, -4.0f);

	dkMaterial_p pBlue = sMap.CreateMaterial(0, 0, 255);
	dkMaterial_p pRed = sMap.CreateMaterial(255, 0, 0);
	dkMaterial_p pGreen = sMap.CreateMaterial(0, 192, 0);
	dkMaterial_p pYellow = sMap.CreateMaterial(255, 255, 0);
	dkMaterial_p pMagenta = sMap.CreateMaterial(255, 0, 255);
	dkMaterial_p pOrange = sMap.CreateMaterial(255, 128, 0);

	dkMaterial_p pBrick = sMap.CreateMaterial(
		"Data\\Tex\\Brick.bmp",
		"Data\\Tex\\Brick_1.bmp",
		"Data\\Tex\\Brick_2.bmp",
		"Data\\Tex\\Brick_3.bmp",
		"Data\\Tex\\Brick_4.bmp",
		"Data\\Tex\\Brick_5.bmp");

//	pBlue = pRed = pGreen = pYellow = pMagenta = pOrange = pBrick;

	dkSector_p pSector = sMap.CreateSector();
	pSector->SetFloorMaterial(dynamic_cast<dkFlatMaterial_p>(sMap.CreateMaterial(128, 128, 128)));
	pSector->SetCeilingMaterial(dynamic_cast<dkFlatMaterial_p>(sMap.CreateMaterial(96, 96, 96)));
	pSector->SetCeilingHeight(3.95f);
	pSector->SetCeilingSlope(-0.1f);
	pSector->SetFloorSlope(-0.25f/32.0f);

	dkWall_p pWall;
	(pWall = pSector->AddWallPair(pVert1, pVert2)->GetNext())->SetMaterial(pRed);
	pWall->GetNext()->SetMaterial(pMagenta);
	(pWall = pSector->SplitWall(pWall, pVert3))->SetMaterial(pGreen);
	dkWall_p pBackWall = pWall;
	(pWall = pSector->SplitWall(pWall, pVert4))->SetMaterial(pBlue);
	(pWall = pSector->SplitWall(pWall, pVert5))->SetMaterial(pOrange);

	(pWall = pSector->AddWallPair(pCVert1, pCVert2)->GetNext())->SetMaterial(pBrick);
	pWall->GetNext()->SetMaterial(pBrick);
	(pWall = pSector->SplitWall(pWall, pCVert3))->SetMaterial(pBrick);
	(pWall = pSector->SplitWall(pWall, pCVert4))->SetMaterial(pBrick);


	pSector = sMap.CreateSector();
	pSector->SetFloorMaterial(dynamic_cast<dkFlatMaterial_p>(sMap.CreateMaterial(96, 96, 96)));
	pSector->SetCeilingMaterial(dynamic_cast<dkFlatMaterial_p>(sMap.CreateMaterial(128, 128, 128)));
	pSector->SetCeilingHeight(0.75f);
	pSector->SetFloorHeight(-1.25f);

	(pWall = pSector->AddWallPair(pVert4, pVert3)->GetNext())->SetMaterial(pRed);
	pWall->GetNext()->SetMaterial(pMagenta);
	pWall->GetPrev()->Join(pBackWall);

	for(int lp=0; lp<32; lp++)
	{
		dkVertex_p pVert = sMap.CreateVertex(16.0f-32.0f*sin(lp*3.14159f/64.0f), 16.0f+32.0f*cos(lp*3.14159f/64.0f));
		(pWall = pSector->SplitWall(pWall, pVert))->SetMaterial((lp%2)?pYellow:pBlue);
	}


	gbFloat fvPlayer[3] = {
		0.0f, 0.0f,		// Position	(Meters)
		0.0f			// Bearing	(Degrees)
	};

	gbFloat fvBaseEye[6] = {
		0.0f, 0.0f,
		-1.0f, 1.0f,
		1.0f, 1.0f,
	};

	BITMAP* pBack = load_bitmap("Data\\Tex\\Sky.bmp", NULL);

	set_trans_blender(96, 96, 96, 96);

	install_int(MainTimer, 10);

	gbInt dwLastFrameCheck = 0;
	gbInt dwFrameCount = 0;
	gbInt dwFrameRate = 0;

	gbFloat fvEye[6];
	gbInt dwGameTime = 0;
	while(!key[KEY_ESC])
	{
		while(g_dwMainTime > 0)
		{
			g_dwMainTime--;
			dwGameTime++;

			gbInt dwMX, dwMY;
			get_mouse_mickeys(&dwMX, &dwMY);
			fvPlayer[2] += dwMX;
			fvPlayer[0] -= sin(fvPlayer[2]*GB_DEG2RAD)*dwMY*0.05f;
			fvPlayer[1] -= -cos(fvPlayer[2]*GB_DEG2RAD)*dwMY*0.05f;

			if((dwGameTime-dwLastFrameCheck) >= 100)
			{
				dwFrameRate = dwFrameCount*100/(dwGameTime-dwLastFrameCheck);
				dwFrameCount = 0;
				dwLastFrameCheck = dwGameTime;
			}
		}

		dwFrameCount++;

//		clear(pBB);
		stretch_blit(pBack, pBB, 0, 0, pBack->w, pBack->h, 0, 0, SCREEN_W, SCREEN_H);

		gbBuildEye(fvBaseEye, fvPlayer[0], fvPlayer[1], fvPlayer[2], fvEye);
		sMap.Draw(pBB, fvEye);

		textprintf_ex(pBB, font, SCREEN_W-90, 4, -1, -1, "FPS: %d", dwFrameRate);

		blit(pBB, screen, 0, 0, 0, 0, SCREEN_W, SCREEN_H);
	}

	destroy_bitmap(pBB);
#if GB_USEVIDBUF==1
	destroy_bitmap(pMainBB);
#endif
}
END_OF_MAIN();

void gbBuildEye(gbFloat* fvIn, gbFloat fX, gbFloat fY, gbFloat fAngle, gbFloat* fvOut)
{
	gbFloat fvMatrix[4];
	fvMatrix[0] = cos(fAngle*GB_DEG2RAD);
	fvMatrix[1] = sin(fAngle*GB_DEG2RAD);
	fvMatrix[2] = fvMatrix[1];
	fvMatrix[3] = -fvMatrix[0];

	fvOut[0] = fvIn[0]*fvMatrix[0]+fvIn[1]*fvMatrix[2]+fX;
	fvOut[1] = fvIn[0]*fvMatrix[1]+fvIn[1]*fvMatrix[3]+fY;
	fvOut[2] = fvIn[2]*fvMatrix[0]+fvIn[3]*fvMatrix[2];
	fvOut[3] = fvIn[2]*fvMatrix[1]+fvIn[3]*fvMatrix[3];
	fvOut[4] = fvIn[4]*fvMatrix[0]+fvIn[5]*fvMatrix[2];
	fvOut[5] = fvIn[4]*fvMatrix[1]+fvIn[5]*fvMatrix[3];
}
