#include <allegro.h>
#include <winalleg.h>
#include "Duke.h"

dkTexMaterial::dkTexMaterial()
{
}

dkTexMaterial::~dkTexMaterial()
{
}

void dkTexMaterial::DrawSliver(BITMAP* pDest, gbInt dwX, gbInt dwY1, gbInt dwY2, gbFloat fU, gbFloat fV1, gbFloat fV2)
{
	fU *= 2.0f;
	while(fU >= 1.0f)
		fU -= 1.0f;
	while(fU < 0.0f)
		fU += 1.0f;

	if(fV1 > fV2)
	{
		gbFloat fT = fV1;
		fV1 = fV2;
		fV2 = fT;
	}
	if(fV1 == fV2)
		fV2 += 0.1f;

	if(dwY2 > dwY1)
	{
		gbInt* pSliver = NULL;
		gbInt dwSliverSize;

		int dwSize = (gbInt)((dwY2-dwY1)/(fV2-fV1));
		if(dwSize < m_dwvSliverSize[4]*3/4)
		{
			pSliver = m_pvSlivers6[((gbInt)((m_pvSlivers6.size()-1)*fU))%m_pvSlivers6.size()];
			dwSliverSize = m_dwvSliverSize[5];
		}
		else if(dwSize < m_dwvSliverSize[3]*3/4)
		{
			pSliver = m_pvSlivers5[((gbInt)((m_pvSlivers5.size()-1)*fU))%m_pvSlivers5.size()];
			dwSliverSize = m_dwvSliverSize[4];
		}
		else if(dwSize < m_dwvSliverSize[2]*3/4)
		{
			pSliver = m_pvSlivers4[((gbInt)((m_pvSlivers4.size()-1)*fU))%m_pvSlivers4.size()];
			dwSliverSize = m_dwvSliverSize[3];
		}
		else if(dwSize < m_dwvSliverSize[1]*3/4)
		{
			pSliver = m_pvSlivers3[((gbInt)((m_pvSlivers3.size()-1)*fU))%m_pvSlivers3.size()];
			dwSliverSize = m_dwvSliverSize[2];
		}
		else if(dwSize < m_dwvSliverSize[0]*3/4)
		{
			pSliver = m_pvSlivers2[((gbInt)((m_pvSlivers2.size()-1)*fU))%m_pvSlivers2.size()];
			dwSliverSize = m_dwvSliverSize[1];
		}
		else
		{
			pSliver = m_pvSlivers1[((gbInt)((m_pvSlivers1.size()-1)*fU))%m_pvSlivers1.size()];
			dwSliverSize = m_dwvSliverSize[0];
		}

		gbFloat fScale = (dwSliverSize-1)/(gbFloat)(dwY2-dwY1);
		fixed fStep = ftofix((fV2-fV1)*fScale);
		fixed fPos = ftofix(fV1*(dwSliverSize-1));

		switch(bitmap_color_depth(pDest))
		{
		case 8:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				_putpixel(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
			break;

		case 15:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				_putpixel15(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
			break;

		case 16:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				_putpixel16(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
			break;

		case 24:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				_putpixel24(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
			break;

		case 32:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				_putpixel32(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
			break;

		default:
			for(int ly=dwY1; ly<=dwY2; ly++)
			{
				putpixel(pDest, dwX, ly, pSliver[ABS(fixtoi(fPos))%dwSliverSize]);
				fPos += fStep;
			}
		}
	}
}

bool dkTexMaterial::Load(
		const gbString& sFile1,
		const gbString& sFile2,
		const gbString& sFile3,
		const gbString& sFile4,
		const gbString& sFile5,
		const gbString& sFile6)
{
	BITMAP* pBmp = load_bitmap(sFile1.c_str(), NULL);
	m_dwvSliverSize[0] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers1.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	pBmp = load_bitmap(sFile2.c_str(), NULL);
	m_dwvSliverSize[1] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers2.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	pBmp = load_bitmap(sFile3.c_str(), NULL);
	m_dwvSliverSize[2] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers3.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	pBmp = load_bitmap(sFile4.c_str(), NULL);
	m_dwvSliverSize[3] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers4.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	pBmp = load_bitmap(sFile5.c_str(), NULL);
	m_dwvSliverSize[4] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers5.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	pBmp = load_bitmap(sFile6.c_str(), NULL);
	m_dwvSliverSize[5] = pBmp->h;
	for(int lx=0; lx<pBmp->w; lx++)
	{
		gbInt* pSliver = new gbInt[pBmp->h];
		for(int ly=0; ly<pBmp->h; ly++)
		{
			pSliver[ly] = getpixel(pBmp, lx, ly);
		}
		m_pvSlivers6.push_back(pSliver);
	}
	destroy_bitmap(pBmp);

	return true;
}
